Anonymous | Login
Project:
RSS
  
News | My View | View Issues | Roadmap | Summary

View Issue DetailsJump to Notes ] Issue History ] Print ]
ID
0007493
TypeCategorySeverityReproducibilityDate SubmittedLast Update
defect[Openbravo ERP] A. Platformminoralways2009-02-11 11:042009-04-22 00:00
ReporterschmidtmView Statuspublic 
Assigned Toalostale 
PrioritynormalResolutionfixedFixed in Version2.50beta
StatusclosedFix in branchFixed in SCM revision13443
ProjectionnoneETAnoneTarget Version
OSAnyDatabasePostgreSQLJava version
OS VersionDatabase versionAnt version
Product Version2.40SCM revision 
Review Assigned To
Web browser
ModulesCore
Regression level
Regression date
Regression introduced by commit
Triggers an Emergency PackNo
Summary

0007493: Application can not be deployed on Servlet 2.4-compliant webcontainer like Glassfish v3

DescriptionWhile migrating OpenBravo to Glassfish v3 (prelude release) we discovered this exception on deployment:

java.lang.IllegalArgumentException: Invalid URL Pattern: [
       /ad_callouts/SL_ProductionPlan_Conversion.html
   ]
       at com.sun.enterprise.deployment.node.web.ServletMappingNode.setElementValue(ServletMappingNode.java:88)
       at com.sun.enterprise.deployment.node.SaxParserHandler.endElement(SaxParserHandler.java:423)

This is because our com.sun.enterprise.util.net.URLPattern.isValid() enforces the Servlet 2.4 spec:

SRV.13.2 Rules for Processing the Deployment Descriptor:

"URI paths specified in the deployment descriptor are assumed to be in URLdecoded
form. The containers must inform the developer with a descriptive
error message when URL contains CR(#xD) or LF(#xA). The containers must
preserve all other characters including whitespace in URL."

This constraint has been added to Servlet-2.4.

Most Servlet-2.3 implementations like tomcat are more forgiving by swalloing this in web.xml:

<url-pattern>
       /ad_callouts/SL_ProductionPlan_Conversion.html
</url-pattern>

Whereas for GFv3 and other 2.4-compliant webcontainers you have to modify this into:

<url-pattern>/ad_callouts/SL_ProductionPlan_Conversion.html</url-pattern>

I bet you don't write these aprox. 2000 servlet-mappings by hand, therefore it should be no big deal
to write them without CR/NL given that it's still backward-compatible and should cause no other grieve.

I've added a patch for your reference.

cheers,

Matthias Schmidt
Sun Microsystems, Inc.

TagsNo tags attached.
Attached Filesgz file icon web.xml.diff.gz [^] (49,950 bytes) 2009-02-11 11:04
patch file icon wad-rv24.patch [^] (946 bytes) 2009-02-11 12:58 [Show Content]

- Relationships Relation Graph ] Dependency Graph ]

-  Notes
(0013341)
jpabloae (reporter)
2009-02-11 12:59

You are right, this is wrong. I attach a patch that should fix it (wad-rv24.patch). I think this should be fixed in trunk and in r2.40.

I reassign this issue to the WAD maintainer (alostale).
(0013783)
svnbot (reporter)
2009-02-20 08:49

Repository: openbravo
Revision: 13443
Author: alostale
Date: 2009-02-20 08:49:06 +0100 (Fri, 20 Feb 2009)

fixed bug 0007493: Application can not be deployed on Servlet 2.4-compliant webcontainer like Glassfish v3

---
U trunk/src-wad/src/org/openbravo/wad/web.xml
---

https://dev.openbravo.com/websvn/openbravo/?rev=13443&sc=1 [^]

- Issue History
Date Modified Username Field Change
2009-02-11 11:04 schmidtm New Issue
2009-02-11 11:04 schmidtm Assigned To => rafaroda
2009-02-11 11:04 schmidtm File Added: web.xml.diff.gz
2009-02-11 11:05 rafaroda Assigned To rafaroda => jpabloae
2009-02-11 11:34 jpabloae Status new => acknowledged
2009-02-11 12:58 jpabloae File Added: wad-rv24.patch
2009-02-11 12:59 jpabloae Note Added: 0013341
2009-02-11 12:59 jpabloae Assigned To jpabloae => alostale
2009-02-18 11:43 alostale Severity critical => minor
2009-02-20 08:49 svnbot Checkin
2009-02-20 08:49 svnbot Note Added: 0013783
2009-02-20 08:49 svnbot Status acknowledged => resolved
2009-02-20 08:49 svnbot Resolution open => fixed
2009-02-20 08:49 svnbot svn_revision => 13443
2009-04-21 10:54 psarobe Status resolved => closed
2009-04-22 00:00 anonymous sf_bug_id 0 => 2777926


Copyright © 2000 - 2009 MantisBT Group
Powered by Mantis Bugtracker